@setlocal
@echo off
@REM IBM Confidential OCO Source Material
@REM 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2015
@REM The source code for this program is not published or otherwise divested
@REM of its trade secrets, irrespective of what has been deposited with the
@REM U.S. Copyright Office.
@REM
@REM

net session >nul 2>&1
IF %ERRORLEVEL% NEQ 0 (
	ECHO The current user must have permission to modify system services.
	GOTO DONE
)

cd %~dp0

set "nannyLoc=%~dp0..\wlp\startscripts\nanny"

@REM Source environment variables
call exportCommons.bat

@REM Register services if not yet registered
sc query XS-Derby >nul 2>&1
IF %ERRORLEVEL% NEQ 0 (
	call "%nannyLoc%\installStartDerbyService.bat" true
)

sc query XS-Nanny-Watch-Dog >nul 2>&1
IF %ERRORLEVEL% NEQ 0 (
	call "%nannyLoc%\installStartWatchDog.bat" true
)

echo.
echo Service Registry Setup
echo.

@REM Get username to run services under
:USERWHILE
set /p enteredUsername=Please enter the user to run XSLD services under:
IF "%enteredUsername%" == "" GOTO USERWHILE

for /f "delims= " %%i in ('"wmic useraccount where name='%enteredUsername%' get sid"') do (
   if not "%%i"=="SID" (          
      set userSID=%%i
      goto :LOOP_END
   )   
)
:LOOP_END

@REM If we can't get an SID prompt again for user account
IF "%userSID%" == "" (
	echo The user account, %enteredUsername% was not found
	GOTO USERWHILE
)

set /p enteredPassword=Please enter the password for %enteredUsername%: 
set "userDomain=."

cls
echo Configuring services for %enteredUsername%...
sc config XS-Derby obj= %userDomain%\%enteredUsername% password= "%enteredPassword%"
sc config XS-Nanny-Watch-Dog obj= %userDomain%\%enteredUsername% password= "%enteredPassword%"

set "authUserSec=(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;%userSID%)"

for /f %%i in ('sc sdshow XS-Derby') do set derbySec=%%i
for /f %%i in ('sc sdshow XS-Nanny-Watch-Dog') do set wdSec=%%i

set "sdStart=%derbySec:~0,2%"
set "sdEnd=%derbySec:~2%"
set "newSec=%sdStart%%authUserSec%%sdEnd%"
sc sdset XS-Derby %newSec%

set "sdStart=%wdSec:~0,2%"
set "sdEnd=%wdSec:~2%"
set "newSec=%sdStart%%authUserSec%%sdEnd%"
sc sdset XS-Nanny-Watch-Dog %newSec%

IF %ERRORLEVEL% EQU 0 (
	ECHO Configuration complete
)

:DONE
pause
